﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hotline
{
    public class AppConfiguration
    {
        public string AppScope { get; set; }
        public YiBinConfiguration YiBin { get; set; }
        public ZiGongConfiguration ZiGong { get; set; }
        public LuZhouConfiguration LuZhou { get; set; }

        public DefaultAppScopeConfiguration GetDefaultAppScopeConfiguration()
        {
            return AppScope switch
            {
                AppDefaults.AppScope.YiBin => YiBin,
                AppDefaults.AppScope.ZiGong => ZiGong,
                AppDefaults.AppScope.LuZhou => LuZhou,
                _ => throw new ArgumentOutOfRangeException()
            };
        }
    }

    public class YiBinConfiguration : DefaultAppScopeConfiguration
    {
    }

    public class ZiGongConfiguration : DefaultAppScopeConfiguration
    {

    }

    public class LuZhouConfiguration : DefaultAppScopeConfiguration
    {

    }

    public abstract class DefaultAppScopeConfiguration
    {
        public string CallCenterType { get; set; }
    }
}
